//+------------------------------------------------------------------+
//|                                             Keltner Channels.mq4 |
//|                                                  Coded by Gilani |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//| MLADEN- Oct, 2010                      http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Magenta
#property indicator_color2 Blue
#property indicator_color3 Magenta

extern string  Indicator_Name    = "RK-KeltnerChannels-Alerts(by ml)";
extern int     period            = 10;
extern double  NumATRs           =0.75;
extern bool    alertsOn          = true;
extern bool    alertsOnCurrent   = False;
//extern double alertsLevel = 5;
extern bool    alertsMessage     = true;
extern bool    alertsSound       = True;
extern bool    alertsEmail       = false;

double upper[], middle[], lower[];
datetime prevtime = 0;

int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,0);
   SetIndexDrawBegin(0,0);
   SetIndexBuffer(0,upper);

   SetIndexStyle(1,DRAW_LINE);
   SetIndexShift(1,0);
   SetIndexDrawBegin(1,0);
   SetIndexBuffer(1,middle);

   SetIndexStyle(2,DRAW_LINE);
   SetIndexShift(2,0);
   SetIndexDrawBegin(2,0);
   SetIndexBuffer(2,lower);
   
   IndicatorShortName("RK-KeltnerChannels-Alert("+period+")"); 
   SetIndexLabel(0,"KC-upper");
   SetIndexLabel(1,"Kc-middle");
   SetIndexLabel(2,"KC-lower");     
return(0);
}
int deinit(){return(0);}
int start() {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double avg;
   
   for(int x=0; x<limit; x++) {
      middle[x] = iMA(NULL, 0, period, 0, MODE_SMA, PRICE_CLOSE, x);
      avg  = findAvg(period, x);
      upper[x] = middle[x] + (avg*NumATRs);
      lower[x] = middle[x] - (avg*NumATRs);
   }
   
   manageAlerts();  
   return(0);
  }
//+------------------------------------------------------------------+
   
 void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      if ((Close[whichBar] > upper[whichBar]) && (prevtime != Time[0]))doAlert(whichBar,"up"  ,1);
      
      if ((Close[whichBar] < lower[whichBar]) && (prevtime != Time[0]))doAlert(whichBar,"down",-1);
   
   }
}
void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," tf-",(Period())," at ",
       TimeToStr(TimeLocal(),TIME_SECONDS)," KC above Alert "+" Bid = "+DoubleToStr(Bid,Digits)+" Ask = "+DoubleToStr(Ask,Digits)
       +"  "+DoubleToStr(value,2)+" KC  Breakout---",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Keltner breakout "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//-------------------------------------------

double findAvg(int period, int shift) {
      double sum=0;
      for (int x=shift;x<(shift+period);x++) {     
         sum += High[x]-Low[x];
      }
      sum = sum/period;
      return (sum);
   }